

/* Saint Michael, Linux Kernel Module.
 * Verions: 0.03
 *
 * June 1, 2001
 *
 *
 *    Copyright (C) 2001  Timothy Lalwess (lawless@netdoor.com)
 *
 *    This program is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU General Public License as
 *    published by the Free Software Foundation; either version 2 of
 *    the License, or (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be
 *    useful, but WITHOUT ANY WARRANTY; without even the implied
 *    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *    PURPOSE.  See the GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 *    USA.
 *      
 *
 * 
 */


#ifdef __SMP__
#include <asm/spinlock.h>
#endif
#include <linux/version.h>

#define VERSION "StMichael 0.03"

#ifdef USE_MD5

#include "md5.h"

#define md5_sample_len 31

typedef struct sm_syscall_record
{
  void *orig_syscall;
  md5_byte_t recorded_digest[16];
}
SM_SYSCALL_RECORD;

#else

typedef void *SM_SYSCALL_RECORD;

#endif

#ifdef __SMP__
rwlock_t sm_running;
#endif

extern void *sys_call_table[];

asmlinkage long (*orig_init_module) (const char *name,
				     struct module * mod_user);
int (*orig_delete_module) (const char *name);

asmlinkage long sm_init_module (const char *name, struct module *mod_user);
int sm_delete_module (const char *name);
